﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.31
@EndOfDesignText@
Sub Class_Globals
	Private mivForeground As B4XView
	Private mivBackground As B4XView
	Private background As BitmapCreator
	Private foreground As BitmapCreator
	Private xui As XUI
	Public Gauges As List
	Private LoopIndex As Int
	Private Transparent As BCBrush
	Public fps As Float
End Sub


Public Sub Initialize (ivForeground As B4XView, ivBackground As B4XView)
	mivForeground = ivForeground
	mivBackground = ivBackground
	background.Initialize(mivBackground.Width / xui.Scale, mivBackground.Height / xui.Scale)
	foreground.Initialize(background.mWidth, background.mHeight)
	Gauges.Initialize
	Transparent = foreground.CreateBrushFromColor(xui.Color_Transparent)
End Sub

Public Sub CreateGauge (x As Int, y As Int, radius As Int, clr As Int) As SimpleGauge
	Dim sg As SimpleGauge
	sg.Initialize(x, y, radius, clr, background)
	Return sg	
End Sub

Public Sub Start
	LoopIndex = LoopIndex + 1
	MainLoop
End Sub

Public Sub Stop
	LoopIndex = LoopIndex + 1
End Sub

Private Sub MainLoop
	background.SetBitmapToImageView(background.Bitmap, mivBackground)
	Dim MyIndex As Int = LoopIndex
	Do While MyIndex = LoopIndex
		Dim n As Long = DateTime.Now
		Dim tasks As List
		tasks.Initialize
		tasks.Add(foreground.AsyncDrawRect(foreground.TargetRect, Transparent, True, 0))
		For Each sg As SimpleGauge In Gauges
			tasks.Add(sg.Draw(foreground))
		Next
		foreground.DrawBitmapCreatorsAsync(Me, "BC", tasks)
		Dim DrawingTime As Long = DateTime.Now
		Wait For BC_BitmapReady (bmp As B4XBitmap)
		If MyIndex <> LoopIndex Then Return
		If xui.IsB4J Then bmp = foreground.Bitmap
		foreground.SetBitmapToImageView(bmp, mivForeground)
		DrawingTime = DateTime.Now - DrawingTime
		Sleep(Max(30 - DrawingTime, 15))
		fps = (fps * 20 + 1000 / (DateTime.Now - n)) / 21
	Loop
End Sub

